<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/filternodes.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>filternodes.c</h1><a href="filternodes_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: filternodes.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="filternodes_8c.html#a51c6bb656314afdc161fd3e74ba7ce98">00029</a> <span class="preprocessor">#define C_REQ -5   </span>
<a name="l00031"></a><a class="code" href="filternodes_8c.html#ab1da8fc65b9539386e71fb8601e36deb">00031</a> <span class="preprocessor">int FilterNodes(int *pn_vert, int *pn_ele, PetscReal **pvertxyz, int *elevert, Vec *pM, Vec *pVH1, Vec *pVH2)</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>{
<a name="l00033"></a>00033   Vec          M,VH1,VH2;
<a name="l00034"></a>00034   PetscReal    *toM,*toVH1,*toVH2;
<a name="l00035"></a>00035   PetscReal    *tnM,*tnVH1,*tnVH2;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keywordtype">int</span> rank,size;
<a name="l00040"></a>00040   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00041"></a>00041   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (rank) {
<a name="l00044"></a>00044     <span class="keywordtype">int</span> n_del;
<a name="l00045"></a>00045     ierr = MPI_Bcast(&amp;n_del,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047     <span class="keywordflow">if</span> (n_del!=0) {
<a name="l00048"></a>00048       ierr = VecCreate(PETSC_COMM_WORLD,&amp;M);CHKERRQ(ierr);
<a name="l00049"></a>00049       ierr = VecSetSizes(M,0,PETSC_DECIDE);CHKERRQ(ierr);
<a name="l00050"></a>00050       ierr = VecSetFromOptions(M);CHKERRQ(ierr);
<a name="l00051"></a>00051       ierr = VecSetBlockSize(M,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00052"></a>00052       ierr = VecDestroy(*pM);CHKERRQ(ierr);
<a name="l00053"></a>00053       *pM=M;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055       <span class="keywordflow">if</span> (*pVH1!=PETSC_NULL) {
<a name="l00056"></a>00056         ierr = VecDuplicate(M,&amp;VH1);CHKERRQ(ierr);
<a name="l00057"></a>00057         ierr = VecDestroy(*pVH1);CHKERRQ(ierr);
<a name="l00058"></a>00058         *pVH1=VH1;
<a name="l00059"></a>00059       }
<a name="l00060"></a>00060       <span class="keywordflow">if</span> (*pVH2!=PETSC_NULL) {
<a name="l00061"></a>00061         ierr = VecDuplicate(M,&amp;VH2);CHKERRQ(ierr);
<a name="l00062"></a>00062         ierr = VecDestroy(*pVH2);CHKERRQ(ierr);
<a name="l00063"></a>00063         *pVH2=VH2;
<a name="l00064"></a>00064       }
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordtype">int</span> n_vert;         n_vert=*pn_vert;
<a name="l00071"></a>00071   <span class="keywordtype">int</span> n_ele;          n_ele=*pn_ele;
<a name="l00072"></a>00072   PetscReal *vertxyz; vertxyz=*pvertxyz;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keywordtype">int</span> *nodesreq;
<a name="l00075"></a>00075   ierr = PetscMalloc(n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;nodesreq);CHKERRQ(ierr);
<a name="l00076"></a>00076   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) nodesreq[i]=<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">/* find all required nodes */</span>
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00080"></a>00080     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00081"></a>00081       nodesreq[elevert[i*NV+j]]=<a class="code" href="filternodes_8c.html#a51c6bb656314afdc161fd3e74ba7ce98">C_REQ</a>;
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083   }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordtype">int</span> n_req=0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="comment">/* create mapping */</span>
<a name="l00088"></a>00088   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00089"></a>00089     <span class="keywordflow">if</span> (nodesreq[i]==<a class="code" href="filternodes_8c.html#a51c6bb656314afdc161fd3e74ba7ce98">C_REQ</a>) {
<a name="l00090"></a>00090       <span class="comment">/* assign new id and update counter */</span>
<a name="l00091"></a>00091       nodesreq[i]=n_req++;
<a name="l00092"></a>00092     }
<a name="l00093"></a>00093   }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">/* get number of nodes to be deleted and inform other processors */</span>
<a name="l00096"></a>00096   <span class="keywordtype">int</span> n_del;
<a name="l00097"></a>00097   n_del=n_vert-n_req;
<a name="l00098"></a>00098   ierr = MPI_Bcast(&amp;n_del,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (n_del!=0) {
<a name="l00101"></a>00101     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00102"></a>00102     <span class="stringliteral">&quot;Unassigned vertices: %i out of %i\n&quot;</span>,n_del,n_vert);
<a name="l00103"></a>00103   }
<a name="l00104"></a>00104   <span class="keywordflow">else</span> {
<a name="l00105"></a>00105     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;No unassigned vertices\n&quot;</span>);
<a name="l00106"></a>00106     ierr = PetscFree(nodesreq);CHKERRQ(ierr);
<a name="l00107"></a>00107     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00108"></a>00108   }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">/* renumber nodes */</span>
<a name="l00111"></a>00111   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00112"></a>00112     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00113"></a>00113       elevert[i*NV+j]=nodesreq[elevert[i*NV+j]];
<a name="l00114"></a>00114       assert(nodesreq[elevert[i*NV+j]]&lt;n_req);
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116     assert(
<a name="l00117"></a>00117       elevert[i*NV+0] !=
<a name="l00118"></a>00118       elevert[i*NV+1] &amp;&amp;
<a name="l00119"></a>00119       elevert[i*NV+0] !=
<a name="l00120"></a>00120       elevert[i*NV+2] &amp;&amp;
<a name="l00121"></a>00121       elevert[i*NV+0] !=
<a name="l00122"></a>00122       elevert[i*NV+3] &amp;&amp;
<a name="l00123"></a>00123       elevert[i*NV+1] !=
<a name="l00124"></a>00124       elevert[i*NV+2] &amp;&amp;
<a name="l00125"></a>00125       elevert[i*NV+1] !=
<a name="l00126"></a>00126       elevert[i*NV+3] &amp;&amp;
<a name="l00127"></a>00127       elevert[i*NV+2] !=
<a name="l00128"></a>00128       elevert[i*NV+3]
<a name="l00129"></a>00129     );
<a name="l00130"></a>00130   }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Updated elements\n&quot;</span>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   PetscReal *tvertxyz;
<a name="l00135"></a>00135   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*n_req*<span class="keyword">sizeof</span>(PetscReal),&amp;tvertxyz);CHKERRQ(ierr);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   ierr = VecCreate(PETSC_COMM_WORLD,&amp;M);CHKERRQ(ierr);
<a name="l00138"></a>00138   ierr = VecSetSizes(M,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*n_req,PETSC_DECIDE);CHKERRQ(ierr);
<a name="l00139"></a>00139   ierr = VecSetFromOptions(M);CHKERRQ(ierr);
<a name="l00140"></a>00140   ierr = VecSetBlockSize(M,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   ierr = VecGetArray(*pM,&amp;toM);CHKERRQ(ierr);
<a name="l00143"></a>00143   ierr = VecGetArray(M,&amp;tnM);CHKERRQ(ierr);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keywordflow">if</span> (*pVH1!=PETSC_NULL) {
<a name="l00146"></a>00146     ierr = VecDuplicate(M,&amp;VH1);CHKERRQ(ierr);
<a name="l00147"></a>00147     ierr = VecGetArray(*pVH1,&amp;toVH1);CHKERRQ(ierr);
<a name="l00148"></a>00148     ierr = VecGetArray(VH1,&amp;tnVH1);CHKERRQ(ierr);
<a name="l00149"></a>00149   }
<a name="l00150"></a>00150   <span class="keywordflow">if</span> (*pVH2!=PETSC_NULL) {
<a name="l00151"></a>00151     ierr = VecDuplicate(M,&amp;VH2);CHKERRQ(ierr);
<a name="l00152"></a>00152     ierr = VecGetArray(*pVH2,&amp;toVH2);CHKERRQ(ierr);
<a name="l00153"></a>00153     ierr = VecGetArray(VH2,&amp;tnVH2);CHKERRQ(ierr);
<a name="l00154"></a>00154   }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordtype">int</span> k=0;
<a name="l00157"></a>00157   <span class="comment">/* update (and compress) vertxyz */</span>
<a name="l00158"></a>00158   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00159"></a>00159     <span class="keywordflow">if</span> (nodesreq[i]!=<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>) {
<a name="l00160"></a>00160       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;j++) {
<a name="l00161"></a>00161         tvertxyz[ND*k+j]=vertxyz[ND*i+j];
<a name="l00162"></a>00162         tnM[ND*k+j]=toM[ND*i+j];
<a name="l00163"></a>00163         <span class="keywordflow">if</span> (*pVH1!=PETSC_NULL) tnVH1[ND*k+j]=toVH1[ND*i+j];
<a name="l00164"></a>00164         <span class="keywordflow">if</span> (*pVH2!=PETSC_NULL) tnVH2[ND*k+j]=toVH2[ND*i+j];
<a name="l00165"></a>00165       }
<a name="l00166"></a>00166       k++;
<a name="l00167"></a>00167     }
<a name="l00168"></a>00168   }
<a name="l00169"></a>00169   assert(k==n_req);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   ierr = VecRestoreArray(*pM,&amp;toM);CHKERRQ(ierr);
<a name="l00172"></a>00172   ierr = VecRestoreArray(M,&amp;tnM);CHKERRQ(ierr);
<a name="l00173"></a>00173   ierr = VecDestroy(*pM);CHKERRQ(ierr);
<a name="l00174"></a>00174   *pM=M;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">if</span> (*pVH1!=PETSC_NULL) {
<a name="l00177"></a>00177     ierr = VecRestoreArray(*pVH1,&amp;toVH1);CHKERRQ(ierr);
<a name="l00178"></a>00178     ierr = VecRestoreArray(VH1,&amp;tnVH1);CHKERRQ(ierr);
<a name="l00179"></a>00179     ierr = VecDestroy(*pVH1);CHKERRQ(ierr);
<a name="l00180"></a>00180     *pVH1=VH1;
<a name="l00181"></a>00181   }
<a name="l00182"></a>00182   <span class="keywordflow">if</span> (*pVH2!=PETSC_NULL) {
<a name="l00183"></a>00183     ierr = VecRestoreArray(*pVH2,&amp;toVH2);CHKERRQ(ierr);
<a name="l00184"></a>00184     ierr = VecRestoreArray(VH2,&amp;tnVH2);CHKERRQ(ierr);
<a name="l00185"></a>00185     ierr = VecDestroy(*pVH2);CHKERRQ(ierr);
<a name="l00186"></a>00186     *pVH2=VH2;
<a name="l00187"></a>00187   }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00190"></a>00190     <span class="stringliteral">&quot;Updated Cartesian coordinates of %i vertices\n&quot;</span>,
<a name="l00191"></a>00191     n_req
<a name="l00192"></a>00192   );
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">/* update counters */</span>
<a name="l00195"></a>00195   *pn_vert=n_req;
<a name="l00196"></a>00196   *pn_ele=n_ele;
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   ierr = PetscFree(*pvertxyz);CHKERRQ(ierr);
<a name="l00199"></a>00199   *pvertxyz=tvertxyz;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   ierr = PetscFree(nodesreq);CHKERRQ(ierr);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00204"></a>00204 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

